#include "opencv2/opencv.hpp"
#include <vector>
#include <string>
#include <iostream>

int main (int argc, char *argv[])
{
	cv::Mat gray = cv::imread("../slovakia.jpg",cv::IMREAD_GRAYSCALE);
	if (gray.empty()) return -1;
	
    cv::namedWindow("Thresholding", 0);
    int threshold = 127;
    int last = -1;
    cv::createTrackbar("threshold", "Thresholding", &threshold, 255, NULL);
    cv::Mat binary;

    for (;;) {
        if (threshold != last) {
            last = threshold;

            if (threshold == 255) 
                cv::threshold(gray,binary,threshold,255,cv::THRESH_BINARY|cv::THRESH_OTSU);
            
            else if (threshold == 0)
                cv::adaptiveThreshold(gray,binary,255,cv::ADAPTIVE_THRESH_GAUSSIAN_C,cv::THRESH_BINARY,15,-5);
            
            else
                //binary = (gray > threshold);
            
                cv::threshold(gray,binary,threshold,255,cv::THRESH_BINARY);
                
            cv::imshow("Thresholding",binary);
        }

		int key = cv::waitKey(10);
		if (key == 27) break;
        else if (key == 's') cv::imwrite("binary.png",binary);
	}
	return 0;
}
