import cv2
import numpy as np
 
threshold = 127

def updateThreshold( *args ):
    global threshold
    threshold = args[0]

cv2.namedWindow("Thresholding")
cv2.createTrackbar("threshold", "Thresholding", threshold, 255, updateThreshold)

gray = cv2.imread("../slovakia.jpg",cv2.IMREAD_GRAYSCALE)

last = -1
while True:
    
    if threshold != last:
        last = threshold
        
        if threshold == 255:
            otsu_threshold, binary = cv2.threshold(gray,0,255,cv2.THRESH_BINARY|cv2.THRESH_OTSU)
            
        elif threshold == 0:
            binary = cv2.adaptiveThreshold(gray,255,cv2.ADAPTIVE_THRESH_GAUSSIAN_C,cv2.THRESH_BINARY,15,-5)
            
        else:
            ##binary = np.zeros(gray.shape,np.uint8)
            #binary = np.zeros_like(gray)
            #binary[gray > threshold] = 255
            
            #binary = np.asarray(gray > threshold,np.uint8)*255
            
            #binary = np.uint8(gray > threshold)*255
            
            #binary = (gray > threshold).astype(np.uint8)*255
            
            _, binary = cv2.threshold(gray,threshold,255,cv2.THRESH_BINARY)
            
        cv2.imshow("Thresholding",binary)
    
    key = cv2.waitKey(10)
    if key == 27:
        break
    elif key == ord('s'):
        cv2.imwrite('binary.png',binary)
    
cv2.destroyAllWindows()
