import cv2
import numpy as np
 
mode = 0
ksize = 1

def updateMode( *args ):
    global mode
    mode = args[0]

def updateKSize( *args ):
    global ksize
    ksize = args[0]

cv2.namedWindow("Morphology")
cv2.createTrackbar("mode", "Morphology", mode, 3, updateMode)
cv2.createTrackbar("ksize", "Morphology", ksize, 25, updateKSize)
last_mode = -1
last_ksize = ksize

binary = cv2.imread("../slovakia-binary.png",cv2.IMREAD_GRAYSCALE)

while True:
    
    if mode != last_mode or ksize != last_ksize:
        last_mode = mode
        last_ksize = ksize
        
        if mode == 0:
            print('erosion')
            binary2 = cv2.erode(binary,cv2.getStructuringElement(cv2.MORPH_RECT,(2*ksize+1,2*ksize+1)))
        elif mode == 1:
            print('dilation')
            binary2 = cv2.dilate(binary,cv2.getStructuringElement(cv2.MORPH_RECT,(2*ksize+1,2*ksize+1)))
        elif mode == 2:
            print('opening')
            binary2 = cv2.morphologyEx(binary,cv2.MORPH_OPEN,cv2.getStructuringElement(cv2.MORPH_RECT,(2*ksize+1,2*ksize+1)))
        elif mode == 3:
            print('closing')
            binary2 = cv2.morphologyEx(binary,cv2.MORPH_CLOSE,cv2.getStructuringElement(cv2.MORPH_RECT,(2*ksize+1,2*ksize+1)))
            
        cv2.imshow("Morphology",binary2)
    
    key = cv2.waitKey(10)
    if key == 27:
        break
    elif key == ord('s'):
        cv2.imwrite("slovakia"+str(mode)+".png",binary2)
    
cv2.destroyAllWindows()
